#!/bin/bash

#SBATCH -J SUNSET_scorecards
#SBATCH --kill-on-invalid-dep=yes

# Slurm directive description:
# -J: job name
# --kill-on-invalid-dep: Whether to kill the job if the dependencies are
#   not satisfied. If the verification jobs fail, the scorecards job 
#   will be canceled.

set -vx

recipe=$1
outdir=$2

source MODULES

# Execute scorecards
Rscript modules/Scorecards/execute_scorecards.R ${recipe} ${outdir}

