source("modules/Loading/Loading.R")
source("modules/Calibration/Calibration.R")
source("modules/Anomalies/Anomalies.R")
source("modules/Skill/Skill.R")
source("modules/Saving/Saving.R")

args = commandArgs(trailingOnly = TRUE)
recipe_file <- args[1]
recipe <- read_atomic_recipe(recipe_file)
# Load datasets
data <- load_datasets(recipe)
# Compute anomalies
data <- compute_anomalies(recipe, data)
# Compute skill metrics 
skill_metrics <- compute_skill_metrics(recipe, data)
