#V.Torralba (February 2025)
CentredWindow <- function(x, window_size){
  # x: vector with the daily data
  # window_size : size of the window that will be used to define robust quantiles
  half_window <- (window_size - 1) / 2
  windows_matrix <- matrix(NA, nrow = length(x), ncol = window_size)
  for (i in 1:length(x)) {
    start <- max(1, i - half_window)
    end <- min(length(x), i+half_window)
    window <- x[start:end]
    window <- c(rep(NA, half_window - (i - start)), window, rep(NA, half_window - (end - i)))
    windows_matrix[i, ] <- window
  }
  return(windows_matrix)
}
